/*
** Module   :RXPIPE.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Fri  09/04/2004	Created
**
*/

#define INCL_DOS
#include <os2.h>
#include <string.h>

#include <buffer.h>
#include <_search.h>
#include <version.h>

#include <fio.h>
#include <stdio.h>

//-----------------------------------------
// Read pipe into memry and filter it using
// given regular expression
//-----------------------------------------

Buffer* filter_pipe(int iPipe, char* expr)
{
    APIRET rc;
    ULONG ulBytesRead = 0;
    int offset = 0;
    ULONG ulReadSz = 256;	//Initial size, it will be extended if necessary

    char* pBuff = new char[ulReadSz+1];
    Buffer* pOut = new Buffer;
	int match_len = 0;

    RXSearch flt;

    if(flt.init(expr, 0) < 0)	//Case sensitive search
    {
    	//Problems with expression
    	return 0;
    }

    for(;;)
    {
        ulBytesRead = 0;

        rc = DosRead(iPipe, pBuff + offset, ulReadSz - offset, &ulBytesRead);

        if(rc || !ulBytesRead)
        	break;

		ulBytesRead += offset;
		pBuff[ulBytesRead] = 0;

		//Split buffer into single strings and pass through filter

		char* ptr;
		char* str;

		offset = 0;

    	for(ptr = str = pBuff; (str - pBuff) < ulBytesRead; )
    	{
	        while(*str && *str != '\n')
    	    {
        	    if(str[0] == '\r' && str[1] != '\n')
            	{
                	str++;
	                break;
    	        }
        	    str++;
	        }

	        if(*str)
    	    {
        	    if((str > pBuff) && str[-1] == '\r')
            	{
	                str[-1] = 0;
    	        }

	            if(str[0] == '\n')
		            *str++ = 0;
        	}
        	else
        	{
        		offset = (str - ptr);

        		if(ptr == pBuff)
				{
					//Buffer is too small for string, expand it

					ulReadSz *= 2;

					char* new_buf = new char[ulReadSz + 1];

					memcpy(new_buf, ptr, offset);
					delete pBuff;

					pBuff = new_buf;
				}
				else
        			memmove(pBuff, ptr, offset);
        		break;
        	}

        	if(flt.search(ptr, match_len))
        	{
        		PLine ln = new Line(ptr);

        		ln->detach();

	        	pOut->Add(ln);
	        }

        	ptr = str;
	    }
    }

    if(offset)
    {
		if(flt.search(pBuff, match_len))
			pOut->Add(new Line(pBuff));
    }

    delete pBuff;

    return pOut;
}

